--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

	local MoverAB1 = CreateFrame("Frame","AB1Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	--MoverAB1:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverAB1:SetPoint("CENTER", UIParent,"BOTTOM",-80, 30)
	MoverAB1:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB1:SetClampedToScreen(true)
	MoverAB1:SetClampRectInsets(0, 0, 0,0)
	local MoverAB1Text  = MoverAB1:CreateFontString(nil, "OVERLAY")
	MoverAB1Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB1Text:SetPoint("CENTER",MoverAB1,"CENTER", 0,0); 
	MoverAB1Text:SetText("")
	
	local Bar1holder = CreateFrame("Frame", "Bar1holder", UIParent, "SecureHandlerStateTemplate")
	--Bar1holder:ClearAllPoints()
	Bar1holder:SetPoint("CENTER", UIParent,"BOTTOM",-80, 30)
	Bar1holder:SetSize(ButtonSize * 12 + MySpacing * 11, ButtonSize)

local function UpdateMe()

	if(Inked.db.profile.lockframes == false) then
		local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB1:GetPoint(n)
			Inked.db.profile.MoverAB1X = xOfs
			Inked.db.profile.MoverAB1Y = yOfs
			Inked.db.profile.MoverAB1Point = point
			MoverAB1Text:SetText("Inked Bar 1")				
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function MakeBar1()
	if Inked.db.profile.UseActionBars == false then return end
	ButtonSize = Inked.db.profile.AB1ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		
	
		-- if  ActionButton1:IsVisible() then
				-- for i = 1, 12 do
						-- local Holder = CreateFrame("Frame",nil,UIParent)
							-- Holder:SetWidth(ButtonSize)
							-- Holder:SetHeight(ButtonSize)
							-- Holder:SetPoint("CENTER", _G["ActionButton"..i],"CENTER",0, 0)
							-- local Holdertex = Holder:CreateTexture(nil, "BACKGROUND")
								-- Holdertex:SetAllPoints()
								-- Holdertex:SetTexture(ThisTexture)
									-- if Inked.db.profile.ClassABColor == true then
										-- Holdertex:SetVertexColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
									-- elseif Inked.db.profile.ClassABColor == false then
										-- if Inked.db.profile.CustomABColor == true then
											-- Holdertex:SetVertexColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
										-- elseif Inked.db.profile.CustomABColor == false then
											-- Holdertex:SetVertexColor(1,1,1,1)
										-- end
									-- end
					
				-- end
			-- end
		
		
		if Inked.db.profile.AB1Layout == 1 then
		--print("layout 1")
			ActionButton1:ClearAllPoints()
			ActionButton1:SetPoint("BOTTOMLEFT", Bar1holder, 0, 0)
			for i = 2, 12 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)
				
			end
			MoverAB1:SetSize((ButtonSize * 12)+12, ButtonSize)
		end
		if Inked.db.profile.AB1Layout == 2 then
	--	print("layout 2")
			ActionButton1:ClearAllPoints()
			ActionButton1:SetPoint("BOTTOMLEFT", Bar1holder, 0, 0)
			_G["ActionButton7"]:ClearAllPoints();
			_G["ActionButton7"]:SetPoint("BOTTOMLEFT", ActionButton1, 0, -ButtonSize+(-MySpacing*1.5))
			for i = 2, 6 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 8,12 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB1:SetSize((ButtonSize * 6)+12, (ButtonSize*2) +12)
		end
		if Inked.db.profile.AB1Layout == 3 then
		--print("layout 3")
			ActionButton1:ClearAllPoints()
			ActionButton1:SetPoint("BOTTOMLEFT", Bar1holder, 0, 0)
			_G["ActionButton5"]:ClearAllPoints();
			_G["ActionButton5"]:SetPoint("BOTTOMLEFT", ActionButton1, 0, -ButtonSize+(-MySpacing*1.5))
			_G["ActionButton9"]:ClearAllPoints();
			_G["ActionButton9"]:SetPoint("BOTTOMLEFT", ActionButton5, 0, -ButtonSize+(-MySpacing*1.5))
			for i = 2, 4 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 6,8 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			for i = 10,12 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB1:SetSize((ButtonSize * 4)+12, (ButtonSize*3) +12)
		end
		if Inked.db.profile.AB1Layout == 4 then
		--print("layout 4")
			ActionButton1:ClearAllPoints()
			ActionButton1:SetPoint("BOTTOMLEFT", Bar1holder, 0, 0)
			for i = 2, 12 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))
				
			end
			MoverAB1:SetSize(ButtonSize, (ButtonSize*12) +12)
		end
		if Inked.db.profile.AB1Layout == 5 then
		--print("layout 5")
			ActionButton1:ClearAllPoints()
			ActionButton1:SetPoint("BOTTOMLEFT", Bar1holder, 0, 0)
			_G["ActionButton7"]:ClearAllPoints();
			_G["ActionButton7"]:SetPoint("BOTTOMLEFT", ActionButton1, -ButtonSize+(-MySpacing*1.5), 0)
			for i = 2, 6 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 8,12 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB1:SetSize((ButtonSize * 2)+12, (ButtonSize*6) +12)
		end
		if Inked.db.profile.AB1Layout == 6 then
		--print("layout 6")
			ActionButton1:ClearAllPoints()
			ActionButton1:SetPoint("BOTTOMLEFT", Bar1holder, 0, 0)
			_G["ActionButton5"]:ClearAllPoints();
			_G["ActionButton5"]:SetPoint("BOTTOMLEFT", ActionButton1, -ButtonSize+(-MySpacing*1.5), 0)
			_G["ActionButton9"]:ClearAllPoints();
			_G["ActionButton9"]:SetPoint("BOTTOMLEFT", ActionButton5, -ButtonSize+(-MySpacing*1.5), 0)

			for i = 2, 4 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 6, 8 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 10,12 do	
				_G["ActionButton"..i]:ClearAllPoints();
				_G["ActionButton"..i]:SetPoint("CENTER", _G["ActionButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB1:SetSize((ButtonSize * 2)+12, (ButtonSize*6) +12)
		end	
		
		for i = 1, 12 do
			local InkedBar1 = _G["ActionButton"..i]
			_G["ActionButton"..i]:SetWidth(ButtonSize)
			_G["ActionButton"..i]:SetHeight(ButtonSize)
			-- _G["ActionButton"..i]:CreateBeautyBorder(BorderSize)
			-- _G["ActionButton"..i]:SetBeautyBorderPadding(BorderPadding)
			-- _G["ActionButton"..i]:SetBeautyBorderTexture("white")
			-- if Inked.db.profile.ClassAB1Color == true then
				-- _G["ActionButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			-- elseif Inked.db.profile.ClassAB1Color == false then
				-- if Inked.db.profile.CustomAB1Color == true then
					-- _G["ActionButton"..i]:SetBeautyBorderColor(Inked.db.profile.AB1ColorR,Inked.db.profile.AB1ColorG,Inked.db.profile.AB1ColorB,Inked.db.profile.AB1ColorA)
				-- elseif Inked.db.profile.CustomAB1Color == false then
					-- _G["ActionButton"..i]:SetBeautyBorderColor(1,1,1,1)
				-- end
			-- end
			
			InkedBar1:SetAttribute("showgrid", 1)
			 InkedBar1:SetAttribute("statehidden", false)
			local fbg = InkedBar1.FloatingBG
			  if fbg then fbg:Hide() end
			--InkedBar1.NormalTexture:SetTexture(nil)
			local Highlight = InkedBar1:GetHighlightTexture()	
			local Pushed = InkedBar1:GetPushedTexture()
			Highlight:SetTexture(HightlightTex)
			Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
			Pushed:SetTexture(PushedTex)		
		end

		if(Inked.db.profile.lockframes == false) then
			MoverAB1:ClearAllPoints()
			Bar1holder:ClearAllPoints()
			if Inked.db.profile.MoverAB1Point == nil then
				MoverAB1:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
				Bar1holder:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
			else
				MoverAB1:SetPoint(Inked.db.profile.MoverAB1Point, UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
				Bar1holder:SetPoint(Inked.db.profile.MoverAB1Point, UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
			end
			CreateMoverBackdrop(MoverAB1)
			MoverAB1:SetMovable(true)
			MoverAB1:EnableMouse(true)
			MoverAB1:RegisterForDrag("LeftButton")
			MoverAB1:SetScript("OnDragStart", MoverAB1.StartMoving)
			MoverAB1:SetScript("OnDragStop", MoverAB1.StopMovingOrSizing)
			MoverAB1:SetUserPlaced(true)
			
						
		elseif Inked.db.profile.MoverAB1Point == nil then
				MoverAB1:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
				Bar1holder:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
				
			else
				MoverAB1:SetPoint(Inked.db.profile.MoverAB1Point, UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
				Bar1holder:SetPoint(Inked.db.profile.MoverAB1Point, UIParent,Inked.db.profile.MoverAB1X,Inked.db.profile.MoverAB1Y)
		end
		if(Inked.db.profile.lockframes == true) then
			Bar1holder:ClearAllPoints()
			Bar1holder:SetPoint("LEFT", MoverAB1, 0, 0)
		end
end		
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()

	if(inBattle == true) then
		return
	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
--print(inBattle)
	if(inBattle == false) then
		MakeBar1()	
	end
end
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:RegisterEvent("PET_BATTLE_OPENING_START")
		InkedLoginFrame:RegisterEvent("PET_BATTLE_CLOSE")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			StartBattlePetsFun()
			EndBattlePetsFun()
			--MakeBar1()									
		end)